// @file GamepadScancodes.h
// @

#pragma once

/*
 * These scancodes were obtained from some knockoff Xbox controller from PowerA.
 * I expect these to be fairly generic, so it's a good base to start from.
 * 
 * Something to keep in mind is the seperation here. On Linux linux/joystick.h
 * is used to read controller inputs. It's a generic driver/library/whatever the
 * fuck it's called.
 *
 * 2 constants are defined in linux/joystick.h
 *
 * 	JS_EVENT_BUTTON
 * 	JS_EVENT_AXIS
 *
 * This is why I made seperate enum classes. Both the Axis and the Button scancode
 * count start from 0x00. Having this seperation is easier to work with.
 *
 * I may write a program in the future to let us harvest scancodes from controllers.
 * I hacked up some C code to get the scancodes for this one without the annoying
 * stick drift spamming the screen, so with a little more work I could probably turn
 * it into a generic test program
 *
 * P.S Windows is gonna make this slightly more annoying and different from what I've
 * seen.
 *
 * - Maxine
 */

enum class GamepadScancode_AXIS {
	ABS_X = 0x00,     // Xbox Left Thumbstick Axis
	ABS_Y = 0x01,     // <-'
	ABS_Z = 0x02,     // Xbox Left Trigger Axis
	ABS_RX = 0x03,    // Xbox Right Thumbstick Axis 
	ABS_RY = 0x04,    // <-'
	ABS_RZ = 0x05,    // Xbox Right Trigger Axis (I know strange ain't it?)
	ABS_HAT0X = 0x06, // Xbox DPad Axis (The Dpad is basically seen as a 3rd thumbstick)
	ABS_HAT0Y = 0x07, // <-'
}
	
enum class GamepadScancode_BTN {
	BTN_SOUTH = 0x00   // Xbox A Button
	BTN_EAST = 0x01    // Xbox B Button
	BTN_WEST = 0x02    // Xbox X Button
	BTN_NORTH = 0x03   // Xbox Y Button
	BTN_TL = 0x04,     // Xbox Left Bumper
	BTN_TR = 0x05,     // Xbox Right Bumper
	BTN_START = 0x06,  // Xbox Start Button
	BTN_SELECT = 0x07, // Xbox Select Button
	BTN_HOME = 0x08,   // Xbox Home/Logo Button
	BTN_THUMBL = 0x09, // Xbox Left Thumstick Button
	BTN_THUMBR = 0x0a, // Xbox Right Thumbstick Button
}
	
