#pragma once

enum class WindowsScancode {
    Nothing = 0,
    ESCAPE = 0x1B,           // VK_ESCAPE
    ONE = 0x31,              // '1'
    TWO = 0x32,              // '2'
    THREE = 0x33,            // '3'
    FOUR = 0x34,             // '4'
    FIVE = 0x35,             // '5'
    SIX = 0x36,              // '6'
    SEVEN = 0x37,            // '7'
    EIGHT = 0x38,            // '8'
    NINE = 0x39,             // '9'
    ZERO = 0x30,             // '0'
    MINUS = 0xBD,            // VK_OEM_MINUS
    EQUALS = 0xBB,           // VK_OEM_PLUS
    BACKSPACE = 0x08,        // VK_BACK
    TAB = 0x09,              // VK_TAB
    Q = 0x51,                // 'Q'
    W = 0x57,                // 'W'
    E = 0x45,                // 'E'
    R = 0x52,                // 'R'
    T = 0x54,                // 'T'
    Y = 0x59,                // 'Y'
    U = 0x55,                // 'U'
    I = 0x49,                // 'I'
    O = 0x4F,                // 'O'
    P = 0x50,                // 'P'
    LEFT_BRACKET = 0xDB,     // VK_OEM_4
    RIGHT_BRACKET = 0xDD,    // VK_OEM_6
    ENTER = 0x0D,            // VK_RETURN
    CTRL = 0x11,             // VK_CONTROL
    A = 0x41,                // 'A'
    S = 0x53,                // 'S'
    D = 0x44,                // 'D'
    F = 0x46,                // 'F'
    G = 0x47,                // 'G'
    H = 0x48,                // 'H'
    J = 0x4A,                // 'J'
    K = 0x4B,                // 'K'
    L = 0x4C,                // 'L'
    SEMICOLON = 0xBA,        // VK_OEM_1
    SINGLEQUOTE = 0xDE,      // VK_OEM_7
    GRAVE = 0xC0,            // VK_OEM_3
    LEFT_SHIFT = 0x10,       // VK_LSHIFT
    BACKSLASH = 0xDC,        // VK_OEM_5
    Z = 0x5A,                // 'Z'
    X = 0x58,                // 'X'
    C = 0x43,                // 'C'
    V = 0x56,                // 'V'
    B = 0x42,                // 'B'
    N = 0x4E,                // 'N'
    M = 0x4D,                // 'M'
    PERIOD = 0xBE,           // VK_OEM_PERIOD
    SLASH = 0xBF,            // VK_OEM_2
    RIGHT_SHIFT = 0xA1,      // VK_RSHIFT
    PRINTSCREEN = 0x2C,      // VK_SNAPSHOT
    ALT = 0x12,              // VK_MENU
    SPACE = 0x20,            // VK_SPACE
    CAPS_LOCK = 0x14,        // VK_CAPITAL
    F1 = 0x70,               // VK_F1
    F2 = 0x71,               // VK_F2
    F3 = 0x72,               // VK_F3
    F4 = 0x73,               // VK_F4
    F5 = 0x74,               // VK_F5
    F6 = 0x75,               // VK_F6
    F7 = 0x76,               // VK_F7
    F8 = 0x77,               // VK_F8
    F9 = 0x78,               // VK_F9
    F10 = 0x79,              // VK_F10
    NUM_LOCK = 0x90,         // VK_NUMLOCK
    SCROLL_LOCK = 0x91,      // VK_SCROLL
    HOME = 0x24,             // VK_HOME
    UP_ARROW = 0x26,         // VK_UP
    PAGE_UP = 0x21,          // VK_PRIOR
    LEFT_ARROW = 0x25,       // VK_LEFT
    DOWN_ARROW = 0x28,       // VK_DOWN
    RIGHT_ARROW = 0x27,      // VK_RIGHT
    END = 0x23,              // VK_END
    PAGE_DOWN = 0x22,        // VK_NEXT
    INSERT = 0x2D,           // VK_INSERT
    DEL = 0x2E,           // VK_DELETE
    F11 = 0x7A,              // VK_F11
    F12 = 0x7B,              // VK_F12

    NUMPAD_ZERO = 0x60,      // VK_NUMPAD0
    NUMPAD_ONE = 0x61,       // VK_NUMPAD1
    NUMPAD_TWO = 0x62,       // VK_NUMPAD2
    NUMPAD_THREE = 0x63,     // VK_NUMPAD3
    NUMPAD_FOUR = 0x64,      // VK_NUMPAD4
    NUMPAD_FIVE = 0x65,      // VK_NUMPAD5
    NUMPAD_SIX = 0x66,       // VK_NUMPAD6
    NUMPAD_SEVEN = 0x67,     // VK_NUMPAD7
    NUMPAD_EIGHT = 0x68,     // VK_NUMPAD8
    NUMPAD_NINE = 0x69,      // VK_NUMPAD9
    NUMPAD_PLUS = 0x6B,      // VK_ADD
    NUMPAD_MINUS = 0x6D,     // VK_SUBTRACT
    NUMPAD_ASTERISK = 0x6A,
    NUMPAD_SLASH = 0x6F,
    NUMPAD_PERIOD = 0x6E,   // VK_DECIMAL
    NUMPAD_ENTER = 0x0D,      // VK_RETURN
    SUPER = 0x5B,
    COMMA = 0xBC,
    MENU = 93,
    BREAK = 0x13
};