// @file X11Scancodes.h
// @

#pragma once

enum class X11Scancode {
    KP_0 = 90,
    KP_1 = 87,
    KP_2 = 88,
    KP_3 = 89,
    KP_4 = 83,
    KP_5 = 84,
    KP_6 = 85,
    KP_7 = 79,
    KP_8 = 80,
    KP_9 = 81,
    KP_PERIOD = 91,
    KP_RETURN = 104,
    KP_PLUS = 86,
    KP_MINUS = 82,
    KP_ASTERISK = 63,
    KP_SLASH = 106,
    KP_NUMLOCK = 77,
    PAGEUP = 112,
    PAGEDOWN = 117,
    HOME = 110,
    MENU = 135,
    END = 115,
    INSERT = 118,
    DEL = 119,
    UP = 111,
    DOWN = 116,
    LEFT = 113,
    RIGHT = 114,
    BACKSPACE = 22,
    EQUALS = 21,
    MINUS = 20,
    ZERO = 19,
    NINE = 18,
    EIGHT = 17,
    SEVEN = 16,
    SIX = 15,
    FIVE = 14,
    FOUR = 13,
    THREE = 12,
    TWO = 11,
    ONE = 10,
    GRAVE = 49,
    BACKSLASH = 51,
    CLOSING_SQUARE_BRACKET = 35,
    OPENING_SQUARE_BRACKET = 34,
    P = 33,
    O = 32,
    I = 31,
    U = 30,
    Y = 29,
    T = 28,
    R = 27,
    E = 26,
    W = 25,
    Q = 24,
    TAB = 23,
    RETURN = 36,
    SINGLEQUOTE = 48,
    SEMICOLON = 47,
    L = 46,
    K = 45,
    J = 44,
    H = 43,
    G = 42,
    F = 41,
    D = 40,
    S = 39,
    A = 38,
    CAPSLOCK = 66,
    RIGHT_SHIFT = 62,
    SLASH = 61,
    PERIOD = 60,
    COMMA = 59,
    M = 58,
    N = 57,
    B = 56,
    V = 55,
    C = 54,
    X = 53,
    Z = 52,
    LEFT_SHIFT = 50,
    RIGHT_CONTROL = 105,
    RIGHT_ALT = 108,
    SPACE = 65,
    LEFT_ALT = 64,
    SUPER = 133,
    LEFT_CTRL = 37,
    ESCAPE = 9,
    F1 = 67,
    F2 = 68,
    F3 = 69,
    F4 = 70,
    F5 = 71,
    F6 = 72,
    F7 = 73,
    F8 = 74,
    F9 = 75,
    F10 = 76,
    F11 = 95,
    F12 = 96,
    PRINT = 107,
    SCROLL_LOCK = 78,
    BREAK = 127,

};
