/// ReWindowLibrary
/// A C++20 Library for creating and managing windows in a platform-independent manner
/// Developed and Maintained by the boys @ Redacted Software.
/// (c) 2024 Redacted Software
/// This work is dedicated to the public domain.

/// @file gamepad.h
/// @desc A class that models the functionality of a gamepad / controller device.
/// @edit 2024-07-29

#pragma once

namespace ReWindow {
    class Gamepad;
    class Xbox360Gamepad;
    class XboxOneGamepad;
    class PS4Gamepad;
    class Ultimate8BitDoPro2Gamepad;
}

class ReWindow::Gamepad {
public:
    virtual ~Gamepad() = default;
};

class ReWindow::XboxOneGamepad : public Gamepad {};
class ReWindow::PS4Gamepad : public Gamepad {};