#include <rewindow/types/display.h>

using namespace ReWindow;

FullscreenGraphicsMode::FullscreenGraphicsMode(u32 width, u32 height, short refresh_rate) {
    this->width = width;
    this->height = height;
    this->refresh_rate = refresh_rate;
}

u32 FullscreenGraphicsMode::getWidth() const {
    return width;
}

u32 FullscreenGraphicsMode::getHeight() const {
    return height;
}

float FullscreenGraphicsMode::getRefreshRate() const {
    return refresh_rate;
}

FullscreenGraphicsMode Display::getDefaultGraphicsMode() {
    return default_graphics_mode;
}

std::vector<FullscreenGraphicsMode> Display::getGraphicsModes() {
    return graphics_modes;
}

Display::Display(const FullscreenGraphicsMode& default_graphics_mode, const std::vector<FullscreenGraphicsMode>& graphics_modes) {
    this->default_graphics_mode = default_graphics_mode;
    this->graphics_modes = graphics_modes;
}
