#include <rewindow/types/mousebutton.h>
#include <string>
#include <X11/X.h>
#include "rewindow/logger/logger.h"


MouseButton::MouseButton(const std::string& charcode, unsigned int index) {
    this->Mnemonic = charcode;
    this->ButtonIndex = index;
}

bool MouseButton::operator==(const MouseButton &mb) const {
    return (mb.ButtonIndex == this->ButtonIndex);
}

bool MouseButton::operator<(const MouseButton &rhs) const {
    return (this->ButtonIndex < rhs.ButtonIndex);
}


MouseButton GetMouseButtonFromXButton(unsigned int button) {
    switch(button) {
        case 1: return MouseButtons::Left;
        case 2: return MouseButtons::Middle;
        case 3: return MouseButtons::Right;
        //case 4: return MouseButtons::MWheelUp;
        //case 5: return MouseButtons::MWheelDown;
            //For *whatever* reason. These aren't in X.h
        case 8: return MouseButtons::Mouse4;
        case 9: return MouseButtons::Mouse5;
        default: {
            ReWindow::Logger::Fatal("Undefined XButtonCode: " + std::to_string((int) button));
            return MouseButtons::Unimplemented;
        }
    }
}